## redkite 1.0.3

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.8)

project(redkite VERSION 1.0.1)

option(ENABLE_EXAMPLES "Build examples" ON)

if (CMAKE_SYSTEM_NAME MATCHES Windows)
  message(STATUS "Build Redkite for Windows")
  add_compile_options(-DRK_OS_WIN)
  add_compile_options(-DRK_FOR_SHARED)
elseif(CMAKE_SYSTEM_NAME MATCHES Darwin)
  message(FATAL_ERROR "Redkite is not implemented yet for Mac OS X")
elseif (CMAKE_SYSTEM_NAME MATCHES Linux)
  message(STATUS " Build Redkite for GNU/Linux")
else()
  message(FATAL_ERROR "Redkite is not implemented yet for ${CMAKE_SYSTEM_NAME}")
endif()

set(RK_INCLUDE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(RK_SRC_PATH ${CMAKE_CURRENT_SOURCE_DIR}/src)
set(RK_EXAMPLES_PATH ${CMAKE_CURRENT_SOURCE_DIR}/examples)
set(RK_TOOLS_PATH ${CMAKE_CURRENT_SOURCE_DIR}/tools)
set(RK_DOC_PATH ${CMAKE_CURRENT_SOURCE_DIR}/doc)

if (NOT CMAKE_BUILD_TYPE)
  message(STATUS "no build type selected, default to Release")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type Release" FORCE)
endif()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_FLAGS "-Wall ${CMAKE_CXX_FLAGS} -fvisibility=hidden")
set(CMAKE_C_FLAGS "-Wall ${CMAKE_C_FLAGS} -fvisibility=hidden")

if (NOT RK_EXPORT_INTERFACE)
  message(STATUS "don't export Redkite interface")
else ()
  message(STATUS "export Redkite interface")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DRK_EXPORT_INTERFACE")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DRK_EXPORT_INTERFACE")
endif ()

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set (CMAKE_INSTALL_PREFIX "/usr/local" CACHE PATH "default install path" FORCE)
endif()

if (NOT CMAKE_INSTALL_LIBDIR)
  message(STATUS "setting the default lib dir path to /usr/lib")
  set(CMAKE_INSTALL_LIBDIR /usr/lib CACHE STRING "lib dir to /usr/lib" FORCE)
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  message(STATUS "enable logging")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DRK_LOG_DEBUG_LEVEL")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DRK_LOG_DEBUG_LEVEL")
endif()

if (NOT RK_GRAPHICS_BACKEND)
  message(STATUS "use default Cairo graphics backend")
  set(RK_GRAPHICS_BACKEND "Cairo")
#  find_package(Cairo REQUIRED)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DRK_GRAPHICS_CAIRO_BACKEND")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DRK_GRAPHICS_CAIRO_BACKEND")
elseif (RK_GRAPHICS_BACKEND MATCHES Cairo)
#  find_package(Cairo REQUIRED)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DRK_GRAPHICS_CAIRO_BACKEND")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DRK_GRAPHICS_CAIRO_BACKEND")
endif()

set(RK_HEADERS
  ${RK_INCLUDE_PATH}/Rk.h
  ${RK_INCLUDE_PATH}/RkObserver.h
  ${RK_INCLUDE_PATH}/RkObject.h
  ${RK_INCLUDE_PATH}/RkAction.h
  ${RK_INCLUDE_PATH}/RkLog.h
  ${RK_INCLUDE_PATH}/RkPoint.h
  ${RK_INCLUDE_PATH}/RkRealPoint.h
  ${RK_INCLUDE_PATH}/RkSize.h
  ${RK_INCLUDE_PATH}/RkRect.h
  ${RK_INCLUDE_PATH}/RkColor.h
  ${RK_INCLUDE_PATH}/RkPen.h
  ${RK_INCLUDE_PATH}/RkFont.h
  ${RK_INCLUDE_PATH}/RkPlatform.h
  ${RK_INCLUDE_PATH}/RkEvent.h
  ${RK_INCLUDE_PATH}/RkEventQueue.h
  ${RK_INCLUDE_PATH}/RkTimer.h
  ${RK_INCLUDE_PATH}/RkWidget.h
  ${RK_INCLUDE_PATH}/RkLabel.h
  ${RK_INCLUDE_PATH}/RkButton.h
  ${RK_INCLUDE_PATH}/RkLineEdit.h
  ${RK_INCLUDE_PATH}/RkProgressBar.h
  ${RK_INCLUDE_PATH}/RkCanvas.h
  ${RK_INCLUDE_PATH}/RkImage.h
  ${RK_INCLUDE_PATH}/RkPainter.h
  ${RK_INCLUDE_PATH}/RkMain.h
  ${RK_INCLUDE_PATH}/RkContainerItem.h
  ${RK_INCLUDE_PATH}/RkContainerWidgetItem.h
  ${RK_INCLUDE_PATH}/RkContainer.h
  ${RK_INCLUDE_PATH}/RkTransition.h)

set(RK_HEADERS_IMPL
  ${RK_INCLUDE_PATH}/impl/RkMainImpl.h
  ${RK_INCLUDE_PATH}/impl/RkObjectImpl.h
  ${RK_INCLUDE_PATH}/impl/RkShortcut.h
  ${RK_INCLUDE_PATH}/impl/RkEventQueueImpl.h
  ${RK_INCLUDE_PATH}/impl/RkWidgetImpl.h
  ${RK_INCLUDE_PATH}/impl/RkLabelImpl.h
  ${RK_INCLUDE_PATH}/impl/RkButtonImpl.h
  ${RK_INCLUDE_PATH}/impl/RkLineEditImpl.h
  ${RK_INCLUDE_PATH}/impl/RkProgressBarImpl.h
  ${RK_INCLUDE_PATH}/impl/RkCanvasInfo.h
  ${RK_INCLUDE_PATH}/impl/RkImageImpl.h
  ${RK_INCLUDE_PATH}/impl/RkPainterImpl.h)

if (RK_GRAPHICS_BACKEND MATCHES Cairo)
  set(RK_GRAPHICS_BACKEND_HEADRES
    ${RK_INCLUDE_PATH}/impl/RkCairoGraphicsBackend.h
    ${RK_INCLUDE_PATH}/impl/RkCairoImageBackendCanvas.h)
  set(RK_GRAPHICS_BACKEND_SOURCES
    ${RK_SRC_PATH}/RkCairoGraphicsBackend.cpp
    ${RK_SRC_PATH}/RkCairoImageBackendCanvas.cpp)
endif()

if(CMAKE_SYSTEM_NAME MATCHES Windows)
set(RK_HEADERS_PLATFORM
  ${RK_INCLUDE_PATH}/impl/platforms/win/RkWindowWin.h
  ${RK_INCLUDE_PATH}/impl/platforms/win/RkEventQueueWin.h)
elseif (CMAKE_SYSTEM_NAME MATCHES Darwin)
set(RK_HEADERS_PLATFORM
  ${RK_INCLUDE_PATH}/impl/platforms/mac/RkWindowMac.h
  ${RK_INCLUDE_PATH}/impl/platforms/mac/RkEventQueueMac.h)
else() # defaut GNU/Linux
set(RK_HEADERS_PLATFORM
  ${RK_INCLUDE_PATH}/impl/platforms/xwin/RkWindowX.h
  ${RK_INCLUDE_PATH}/impl/platforms/xwin/RkEventQueueX.h)
endif()

set(RK_SOURCES
  ${RK_SRC_PATH}/RkObject.cpp
  ${RK_SRC_PATH}/RkObjectImpl.cpp
  ${RK_SRC_PATH}/RkWidget.cpp
  ${RK_SRC_PATH}/RkWidgetImpl.cpp
  ${RK_SRC_PATH}/RkMain.cpp
  ${RK_SRC_PATH}/RkEventQueue.cpp
  ${RK_SRC_PATH}/RkTimer.cpp
  ${RK_SRC_PATH}/RkEventQueueImpl.cpp
  ${RK_SRC_PATH}/RkMainImpl.cpp
  ${RK_SRC_PATH}/RkLabel.cpp
  ${RK_SRC_PATH}/RkLabelImpl.cpp
  ${RK_SRC_PATH}/RkButton.cpp
  ${RK_SRC_PATH}/RkButtonImpl.cpp
  ${RK_SRC_PATH}/RkLineEdit.cpp
  ${RK_SRC_PATH}/RkLineEditImpl.cpp
  ${RK_SRC_PATH}/RkProgressBar.cpp
  ${RK_SRC_PATH}/RkProgressBarImpl.cpp
  ${RK_SRC_PATH}/RkPainter.cpp
  ${RK_SRC_PATH}/RkImage.cpp
  ${RK_SRC_PATH}/RkImageImpl.cpp
  ${RK_SRC_PATH}/RkPainterImpl.cpp
  ${RK_SRC_PATH}/RkContainer.cpp)

if (CMAKE_SYSTEM_NAME MATCHES Windows)
  set(RK_SOURCES_PLATFORM
    ${RK_SRC_PATH}/platforms/win/RkLogWin.cpp
    ${RK_SRC_PATH}/platforms/win/RkPlatformWin.cpp
    ${RK_SRC_PATH}/platforms/win/RkWindowWin.cpp
    ${RK_SRC_PATH}/platforms/win/RkEventQueueWin.cpp)
elseif (CMAKE_SYSTEM_NAME MATCHES Darwin)
  set(RK_SOURCES_PLATFORM
    ${RK_SRC_PATH}/platforms/mac/RkPlatformMac.cpp
    ${RK_SRC_PATH}/platforms/mac/RkWindowMac.cpp
    ${RK_SRC_PATH}/platforms/mac/RkEventQueueMac.cpp)
else() # defaut GNU/Linux
  set(RK_SOURCES_PLATFORM
    ${RK_SRC_PATH}/platforms/xwin/RkLogX.cpp
    ${RK_SRC_PATH}/platforms/xwin/RkPlatformX.cpp
    ${RK_SRC_PATH}/platforms/xwin/RkWindowX.cpp
    ${RK_SRC_PATH}/platforms/xwin/RkEventQueueX.cpp)
endif()

add_definitions(-fPIC)
include_directories(${RK_INCLUDE_PATH})
include_directories(${RK_INCLUDE_PATH}/impl)

if (CMAKE_SYSTEM_NAME MATCHES Windows)
  include_directories(${RK_INCLUDE_PATH}/impl/platforms/win)
elseif (CMAKE_SYSTEM_NAME MATCHES Darwin)
  include_directories(${RK_INCLUDE_PATH}/impl/platforms/mac)
# not implemented yet
else() # defualt GNU/Linux
include_directories(${RK_INCLUDE_PATH}/impl/platforms/xwin)
endif()

# Redkite is not supposed to be provided as shared library,
# it must be only as static library for development.
add_library(redkite STATIC
  ${RK_HEADERS}
  ${RK_HEADERS_IMPL}
  ${RK_HEADERS_PLATFORM}
  ${RK_GRAPHICS_BACKEND_HEADRES}
  ${RK_GRAPHICS_BACKEND_SOURCES}
  ${RK_SOURCES}
  ${RK_SOURCES_PLATFORM})

if (CMAKE_SYSTEM_NAME MATCHES Windows)
  install(TARGETS redkite DESTINATION ${CMAKE_INSTALL_PREFIX})
  install(FILES ${RK_HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/include)
elseif(CMAKE_SYSTEM_NAME MATCHES Darwin)
# Not implemented
else()
  install(TARGETS redkite DESTINATION ${CMAKE_INSTALL_LIBDIR})
  install(FILES ${RK_HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/include/redkite)
endif()

add_subdirectory(tools)
if (ENABLE_EXAMPLES)
  add_subdirectory(examples)
endif (ENABLE_EXAMPLES)

=== debian/changelog ===
redkite (1.0.3-0ubuntu4) groovy; urgency=medium

  * Bump compat, standards

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Mon, 14 Sep 2020 15:43:32 -0700

redkite (1.0.3-0ubuntu3) groovy; urgency=medium

  * Fix manpage path 

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Sun, 16 Aug 2020 15:14:27 -0700

redkite (1.0.3-0ubuntu2) groovy; urgency=medium

  * Include manpage

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Sun, 16 Aug 2020 22:05:54 +0000

redkite (1.0.3-0ubuntu1) groovy; urgency=medium

  * New upstream release 1.0.3
  * Features
    - RkObject and object tree ownership
    - RkContainerItem, now continer supports space, RkWidget and RkContainter items
    - Popup widget
    - Hover event
    - RkTransition - linear transition from one value to another, useful for effects
    - RkAction, useful to execute synchronous actions
    - Shortcuts
  * Improvements
    - RkContainer
    - RkEventQueue
    - RkWidget
    - RkButton
    - events, actions and objects binds
  * Fixes since 1.0.0
    - fix for copy constructor of RkImage
    - some cleanup of useless code
  * Fixes since 1.0.1
    - some fixes for potential clang compile errors
  * Fixes since 1.0.2
    - include in Rk.h file (fix a potential clang compile error)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Fri, 14 Aug 2020 16:00:30 +0000

redkite (0.8.1-0ubuntu1) groovy; urgency=medium

  * Initial release for Ubuntu

 -- Erich Eickmeyer <erich@ericheickmeyer.com>  Wed, 03 Jun 2020 10:29:07 -0700

Old changelog:

redkite-static (5:0.8.1-1kxstudio1) bionic; urgency=medium

  * Update

 -- falkTX <falktx@gmail.com>  Sun, 31 May 2020 06:14:35 +0100

redkite-static (5:0.6.3-1kxstudio1) bionic; urgency=medium

  * New package

 -- falkTX <falktx@gmail.com>  Sun, 15 Sep 2019 14:12:37 +0100

## redkite 1.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required (VERSION 3.8)
 
-project(redkite VERSION 1.0.1)
+project(redkite VERSION 1.3.1)
 
 option(ENABLE_EXAMPLES "Build examples" ON)
 
@@ -68,6 +68,7 @@
 
 set(RK_HEADERS
   ${RK_INCLUDE_PATH}/Rk.h
+  ${RK_INCLUDE_PATH}/RkVariant.h
   ${RK_INCLUDE_PATH}/RkObserver.h
   ${RK_INCLUDE_PATH}/RkObject.h
   ${RK_INCLUDE_PATH}/RkAction.h
@@ -87,11 +88,13 @@
   ${RK_INCLUDE_PATH}/RkLabel.h
   ${RK_INCLUDE_PATH}/RkButton.h
   ${RK_INCLUDE_PATH}/RkLineEdit.h
+  ${RK_INCLUDE_PATH}/RkList.h
   ${RK_INCLUDE_PATH}/RkProgressBar.h
   ${RK_INCLUDE_PATH}/RkCanvas.h
   ${RK_INCLUDE_PATH}/RkImage.h
   ${RK_INCLUDE_PATH}/RkPainter.h
   ${RK_INCLUDE_PATH}/RkMain.h
+  ${RK_INCLUDE_PATH}/RkModel.h
   ${RK_INCLUDE_PATH}/RkContainerItem.h
   ${RK_INCLUDE_PATH}/RkContainerWidgetItem.h
   ${RK_INCLUDE_PATH}/RkContainer.h
@@ -104,6 +107,8 @@
   ${RK_INCLUDE_PATH}/impl/RkEventQueueImpl.h
   ${RK_INCLUDE_PATH}/impl/RkWidgetImpl.h
   ${RK_INCLUDE_PATH}/impl/RkLabelImpl.h
+  ${RK_INCLUDE_PATH}/impl/RkListImpl.h
+  ${RK_INCLUDE_PATH}/impl/RkModelImpl.h
   ${RK_INCLUDE_PATH}/impl/RkButtonImpl.h
   ${RK_INCLUDE_PATH}/impl/RkLineEditImpl.h
   ${RK_INCLUDE_PATH}/impl/RkProgressBarImpl.h
@@ -129,7 +134,7 @@
   ${RK_INCLUDE_PATH}/impl/platforms/mac/RkWindowMac.h
   ${RK_INCLUDE_PATH}/impl/platforms/mac/RkEventQueueMac.h)
 else() # defaut GNU/Linux
-set(RK_HEADERS_PLATFORM
+  set(RK_HEADERS_PLATFORM
   ${RK_INCLUDE_PATH}/impl/platforms/xwin/RkWindowX.h
   ${RK_INCLUDE_PATH}/impl/platforms/xwin/RkEventQueueX.h)
 endif()
@@ -144,12 +149,16 @@
   ${RK_SRC_PATH}/RkTimer.cpp
   ${RK_SRC_PATH}/RkEventQueueImpl.cpp
   ${RK_SRC_PATH}/RkMainImpl.cpp
+  ${RK_SRC_PATH}/RkModel.cpp
+  ${RK_SRC_PATH}/RkModelImpl.cpp
   ${RK_SRC_PATH}/RkLabel.cpp
   ${RK_SRC_PATH}/RkLabelImpl.cpp
   ${RK_SRC_PATH}/RkButton.cpp
   ${RK_SRC_PATH}/RkButtonImpl.cpp
   ${RK_SRC_PATH}/RkLineEdit.cpp
   ${RK_SRC_PATH}/RkLineEditImpl.cpp
+  ${RK_SRC_PATH}/RkList.cpp
+  ${RK_SRC_PATH}/RkListImpl.cpp
   ${RK_SRC_PATH}/RkProgressBar.cpp
   ${RK_SRC_PATH}/RkProgressBarImpl.cpp
   ${RK_SRC_PATH}/RkPainter.cpp

=== examples/CMakeLists.txt ===
set(RK_EXAMPLES_SOURCES ${RK_EXAMPLES_PATH}/HelloWorld.cpp)
set(RK_EXAMPLES_SOURCES_MULTI ${RK_EXAMPLES_PATH}/hello_multi.cpp)
set(RK_EXAMPLES_SOURCES_CHILD ${RK_EXAMPLES_PATH}/child.cpp)
set(RK_EXAMPLES_SOURCES_PROPERTY ${RK_EXAMPLES_PATH}/property.cpp)
set(RK_EXAMPLES_SOURCES_LABEL ${RK_EXAMPLES_PATH}/label.cpp)
set(RK_EXAMPLES_SOURCES_WIDGET_COLORS ${RK_EXAMPLES_PATH}/widget_colors.cpp)
set(RK_EXAMPLES_SOURCES_PAINTER ${RK_EXAMPLES_PATH}/Painter.cpp)
set(RK_EXAMPLES_SOURCES_ACTION ${RK_EXAMPLES_PATH}/action.cpp)
set(RK_EXAMPLES_SOURCES_DIALOG ${RK_EXAMPLES_PATH}/dialog.cpp)
set(RK_EXAMPLES_SOURCES_TIMER ${RK_EXAMPLES_PATH}/timer.cpp)
set(RK_EXAMPLES_SOURCES_KEYEVENT ${RK_EXAMPLES_PATH}/keyevent.cpp)
set(RK_EXAMPLES_SOURCES_LINEEDIT ${RK_EXAMPLES_PATH}/lineedit.cpp)
set(RK_EXAMPLES_SOURCES_BUTTON ${RK_EXAMPLES_PATH}/Button.cpp)
set(RK_EXAMPLES_SOURCES_CONTAINER ${RK_EXAMPLES_PATH}/WidgetContainer.cpp)
set(RK_EXAMPLES_SOURCES_TRANSITION ${RK_EXAMPLES_PATH}/Transition.cpp)
set(RK_EXAMPLES_SOURCES_POPUP ${RK_EXAMPLES_PATH}/Popup.cpp)

if (MSVC)
  set(RK_EXEC_OPTION WIN32)
else()
  set(RK_EXEC_OPTION "")
endif()

if (RK_GRAPHICS_BACKEND MATCHES Cairo)
  set(RK_GRAPHICS_BACKEND_LINK_LIBS "-lcairo")
endif()


#------- Hello World Example -----

add_executable(HelloWorld ${RK_EXEC_OPTION}
	${RK_HEADERS}
	${RK_EXAMPLES_SOURCES})

add_dependencies(HelloWorld redkite)
target_link_libraries(HelloWorld redkite)
if (CMAKE_SYSTEM_NAME MATCHES Windows)
  target_link_libraries(HelloWorld "-mwindows -lstdc++ -lm -lmingw32")
  target_link_libraries(HelloWorld ${RK_GRAPHICS_BACKEND_LINK_LIBS})
else()
  target_link_libraries(HelloWorld "-lX11 -lpthread -lrt -lm -ldl")
  target_link_libraries(HelloWorld ${RK_GRAPHICS_BACKEND_LINK_LIBS})
endif()

# ------------ Multithreading Example -------

add_executable(hello_multi
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_MULTI})

add_dependencies(hello_multi redkite)
target_link_libraries(hello_multi redkite)
target_link_libraries(hello_multi "-lX11 -lpthread -lrt -lm -ldl")
target_link_libraries(hello_multi ${RK_GRAPHICS_BACKEND_LINK_LIBS})

# ------------ Child Example -------

add_executable(child ${RK_EXEC_OPTION}
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_CHILD})
add_dependencies(child redkite)
target_link_libraries(child redkite)
if (CMAKE_SYSTEM_NAME MATCHES Windows)
  target_link_libraries(child "-mwindows -lstdc++ -lm -lmingw32")
  target_link_libraries(child ${RK_GRAPHICS_BACKEND_LINK_LIBS})
else()
  target_link_libraries(child "-lX11 -lpthread -lrt -lm -ldl")
  target_link_libraries(child ${RK_GRAPHICS_BACKEND_LINK_LIBS})
endif()

# ------------ Property -------

add_executable(property
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_PROPERTY})

add_dependencies(property redkite)
target_link_libraries(property redkite)
target_link_libraries(property "-lX11 -lrt -lm -ldl")
target_link_libraries(property ${RK_GRAPHICS_BACKEND_LINK_LIBS})

# ------------ Label Example -------

add_executable(label
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_LABEL})

add_dependencies(label redkite)
target_link_libraries(label redkite)
target_link_libraries(label "-lX11 -lrt -lm -ldl")
target_link_libraries(label ${RK_GRAPHICS_BACKEND_LINK_LIBS})

#------------- Widget Colors --------

add_executable(widget_colors
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_WIDGET_COLORS})

add_dependencies(widget_colors redkite)
target_link_libraries(widget_colors redkite)
target_link_libraries(widget_colors "-lX11 -lrt -lm -ldl")
target_link_libraries(widget_colors ${RK_GRAPHICS_BACKEND_LINK_LIBS})

#------- Painter Example -----

add_executable(Painter
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_PAINTER})

add_dependencies(Painter redkite)
target_link_libraries(Painter redkite)
target_link_libraries(Painter "-lX11 -lrt -lm -ldl")
target_link_libraries(Painter ${RK_GRAPHICS_BACKEND_LINK_LIBS})

# ------------ Action Exmaple -------

add_executable(action
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_ACTION})

add_dependencies(action redkite)
target_link_libraries(action redkite)
target_link_libraries(action "-lX11 -lrt -lm -ldl")
target_link_libraries(action ${RK_GRAPHICS_BACKEND_LINK_LIBS})


# ------------ Dialog example -------

add_executable(dialog
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_DIALOG})

add_dependencies(dialog redkite)
target_link_libraries(dialog redkite)
target_link_libraries(dialog "-lX11 -lrt -lm -ldl")
target_link_libraries(dialog ${RK_GRAPHICS_BACKEND_LINK_LIBS})

# ------------ Timer example -------

add_executable(timer
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_TIMER})

add_dependencies(timer redkite)
target_link_libraries(timer redkite)
target_link_libraries(timer "-lX11 -lrt -lm -ldl")
target_link_libraries(timer ${RK_GRAPHICS_BACKEND_LINK_LIBS})

# ------------ KeyEvent example -------

add_executable(keyevent
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_KEYEVENT})

add_dependencies(keyevent redkite)
target_link_libraries(keyevent redkite)
target_link_libraries(keyevent "-lX11 -lrt -lm -ldl")
target_link_libraries(keyevent ${RK_GRAPHICS_BACKEND_LINK_LIBS})

# ------------ RkLineEdit example -------

add_executable(lineedit
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_LINEEDIT})

add_dependencies(lineedit redkite)
target_link_libraries(lineedit redkite)
target_link_libraries(lineedit "-lX11 -lrt -lm -ldl")
target_link_libraries(lineedit ${RK_GRAPHICS_BACKEND_LINK_LIBS})

# ------------ RkButton example -------

add_executable(button
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_BUTTON})

add_dependencies(button redkite)
target_link_libraries(button redkite)
target_link_libraries(button "-lX11 -lrt -lm -ldl")
target_link_libraries(button ${RK_GRAPHICS_BACKEND_LINK_LIBS})

# ------------ RkWidgetContainer example -------

add_executable(WidgetContainer
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_CONTAINER})

add_dependencies(WidgetContainer redkite)
target_link_libraries(WidgetContainer redkite)
target_link_libraries(WidgetContainer "-lX11 -lrt -lm -ldl")
target_link_libraries(WidgetContainer ${RK_GRAPHICS_BACKEND_LINK_LIBS})

# ------------ RkTransition example -------

add_executable(Transition
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_TRANSITION})

add_dependencies(Transition redkite)
target_link_libraries(Transition redkite)
target_link_libraries(Transition "-lX11 -lrt -lm -ldl")
target_link_libraries(Transition ${RK_GRAPHICS_BACKEND_LINK_LIBS})

# ------------ Popup example -------

add_executable(Popup
  ${RK_HEADERS}
  ${RK_EXAMPLES_SOURCES_POPUP})

add_dependencies(Popup redkite)
target_link_libraries(Popup redkite)
target_link_libraries(Popup "-lX11 -lrt -lm -ldl")
target_link_libraries(Popup ${RK_GRAPHICS_BACKEND_LINK_LIBS})

=== tools/CMakeLists.txt ===
set(RK_TOOLS_SOURCES ${RK_TOOLS_PATH}/rkpng2c.c)

if (RK_GRAPHICS_BACKEND MATCHES Cairo)
  set(RK_GRAPHICS_BACKEND_LINK_LIBS "-lcairo")
endif()

add_executable(rkpng2c ${RK_EXEC_OPTION} ${RK_TOOLS_SOURCES})

if (CMAKE_SYSTEM_NAME MATCHES Windows)
  target_link_libraries(rkpng2c "-mwindows -lstdc++ -lm -lmingw32")
  target_link_libraries(rkpng2c ${RK_GRAPHICS_BACKEND_LINK_LIBS})
else()
  target_link_libraries(rkpng2c ${RK_GRAPHICS_BACKEND_LINK_LIBS})
endif()

install(TARGETS rkpng2c DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
install(FILES ${RK_DOC_PATH}/man/rkpng2c.1  DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)

=== debian/changelog ===
redkite (1.3.1-0ubuntu1) hirsute; urgency=medium

  * New upstream bugfix release 1.3.1

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Sat, 27 Feb 2021 10:08:55 -0800

redkite (1.3.0-0ubuntu1) hirsute; urgency=medium

  * New upstream release
  * Fix close screen for top window
  * Fix crash for popups
  * Fixes button
  * Improved buttons
  * Improved popup
  * Do not use transient for popups
  * Close event programmatically
  * RkString just a std::string defined type for now

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Wed, 16 Dec 2020 08:12:03 -0800

redkite (1.2.0-0ubuntu1) hirsute; urgency=medium

  * New upstream release 1.2.0
  * Changes since 1.0.3
    - RkList - a list view (still not supporting scroll)
    - RkModel - a simple abstract class for creating models
    - RkVariant - just type def of std::vaiant that supports std::string,
      RkColor, RkSize and RkFont
    - UI scaling (useful for so-called HiDPI cases)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Tue, 03 Nov 2020 13:41:31 -0800

=== debian/control ===
Source: redkite
Section: libs
Priority: optional
Maintainer: Erich Eickmeyer <eeickmeyer@ubuntu.com>
XSBC-Original-Maintainer: falkTX <falktx@falktx.com>
Build-Depends: debhelper-compat (= 13),
  cmake,
  pkg-config,
  libcairo2-dev,
  libx11-dev,
Standards-Version: 4.5.0

Package: libredkite-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: small GUI toolkit
 Redkite is a small free software GUI toolkit.
 It is developed in C++17 and inspired from other well known GUI toolkits.
